<?php
/**
* Plugin YouTube: Create YouTube link and object from ID.
*
* @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
* @author     Ikuo Obataya<ikuo_obataya@symplus.co.jp>
*/
 
// must be run within Dokuwiki
if(!defined('DOKU_INC')) die();
 
if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'syntax.php');
 
/**
* All DokuWiki plugins to extend the parser/rendering mechanism
* need to inherit from this class
*/
class syntax_plugin_youtube extends DokuWiki_Syntax_Plugin {
	/**
	* return some info
	*/
	function getInfo(){
		return array(
		'author' => 'Ikuo Obataya',
		'email'  => 'ikuo_obataya@symplus.co.jp',
		'date'   => '2007-04-11',
		'name'   => 'YouTube Plugin',
		'desc'   => 'YouTube link and object',
		'url'    => 'http://wiki.symplus.co.jp/computer:youtube_plugin',
		);
	}
	function getType(){ return 'substition'; }
	function getSort(){ return 159; }
	function connectTo($mode) { $this->Lexer->addSpecialPattern('\{\{youtube>[^}]*\}\}',$mode,'plugin_youtube'); }
	
	/**
	* Handle the match
	*/
	function handle($match, $state, $pos, &$handler){
		$match = substr($match,10,-2); // Strip markup
		return array($state,explode(':',$match));
	}	
	/**
	* Create output
	*/
	function render($mode, &$renderer, $data) {
		if($mode == 'xhtml'){
			list($state, $match) = $data;
			list($disptype,$id) = $match;
			$href_start = '<a href="http://www.youtube.com/watch?v='.$id.'">';
			$LOGO_URL = '/_media/icon/youtube.png';
			if ($disptype=='link'){
				$renderer->doc .= $href_start;
				$renderer->doc .= '<img src="'.$LOGO_URL.'" alt="movie-'.$id.'"/></a>';
			}elseif($disptype=='large'){
				$obj='<object width="425" height="350"  type="application/x-shockwave-flash" data="http://www.youtube.com/v/'.$id.'">';
				$obj.= '<param name="movie" value="http://www.youtube.com/v/'.$id.'"></param>';
				$obj.='<param name="wmode" value="transparent"></param></object>';
				$renderer->doc .= $obj;
			}elseif($disptype=='small'){
				$obj='<object width="255" height="210"  type="application/x-shockwave-flash" data="http://www.youtube.com/v/'.$id.'">';
				$obj.= '<param name="movie" value="http://www.youtube.com/v/'.$id.'"></param>';
				$obj.='<param name="wmode" value="transparent"></param></object>';
				$renderer->doc .= $obj;
			}else{
				$renderer->doc .="??";
			}
			return true;
		}
		return false;
	}
}
?>
